From 3dacde91e1537fce54ccce74000fd2a647464668 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 14 2020 04:13:06 +0000
Subject: [PATCH 876/2232] Merge pull request #299 from dtolnay/output


Add -o flag to set output file for cli
---

diff --git a/gen/cmd/src/app.rs b/gen/cmd/src/app.rs
index dce7a5a..caab254 100644
--- a/gen/cmd/src/app.rs
+++ b/gen/cmd/src/app.rs
@@ -2,7 +2,7 @@
 #[path = "test.rs"]
 mod test;
 
-use super::Opt;
+use super::{Opt, Output};
 use clap::AppSettings;
 use std::ffi::{OsStr, OsString};
 use std::path::PathBuf;
@@ -39,6 +39,7 @@ fn app() -> App {
         .arg(arg_cxx_impl_annotations())
         .arg(arg_header())
         .arg(arg_include())
+        .arg(arg_output())
         .help_message("Print help information.")
         .version_message("Print version information.");
     if let Some(version) = option_env!("CARGO_PKG_VERSION") {
@@ -51,6 +52,7 @@ const INPUT: &str = "input";
 const CXX_IMPL_ANNOTATIONS: &str = "cxx-impl-annotations";
 const HEADER: &str = "header";
 const INCLUDE: &str = "include";
+const OUTPUT: &str = "output";
 
 pub(super) fn from_args() -> Opt {
     let matches = app().get_matches();
@@ -61,6 +63,11 @@ pub(super) fn from_args() -> Opt {
         include: matches
             .values_of(INCLUDE)
             .map_or_else(Vec::new, |v| v.map(str::to_owned).collect()),
+        output: match matches.value_of_os(OUTPUT) {
+            None => Output::Stdout,
+            Some(path) if path == "-" => Output::Stdout,
+            Some(path) => Output::File(PathBuf::from(path)),
+        },
     }
 }
 
@@ -114,3 +121,16 @@ into the generated C++ code as #include lines.
         .validator_os(validate_utf8)
         .help(HELP)
 }
+
+fn arg_output() -> Arg {
+    const HELP: &str = "\
+Path of file to write as output. Output goes to stdout if -o is
+not specified.
+    ";
+    Arg::with_name(OUTPUT)
+        .long(OUTPUT)
+        .short("o")
+        .takes_value(true)
+        .validator_os(validate_utf8)
+        .help(HELP)
+}
diff --git a/gen/cmd/src/main.rs b/gen/cmd/src/main.rs
index 14b75e6..834b738 100644
--- a/gen/cmd/src/main.rs
+++ b/gen/cmd/src/main.rs
@@ -11,9 +11,11 @@ mod app;
 mod gen;
 mod syntax;
 
-use gen::include;
+use gen::error::{report, Result};
+use gen::{fs, include};
 use std::io::{self, Write};
 use std::path::PathBuf;
+use std::process;
 
 #[derive(Debug)]
 struct Opt {
@@ -21,13 +23,23 @@ struct Opt {
     header: bool,
     cxx_impl_annotations: Option<String>,
     include: Vec<String>,
+    output: Output,
 }
 
-fn write(content: impl AsRef<[u8]>) {
-    let _ = io::stdout().lock().write_all(content.as_ref());
+#[derive(Debug)]
+enum Output {
+    Stdout,
+    File(PathBuf),
 }
 
 fn main() {
+    if let Err(err) = try_main() {
+        let _ = writeln!(io::stderr(), "cxxbridge: {}", report(err));
+        process::exit(1);
+    }
+}
+
+fn try_main() -> Result<()> {
     let opt = app::from_args();
 
     let gen = gen::Opt {
@@ -37,10 +49,24 @@ fn main() {
         gen_implementation: !opt.header,
     };
 
-    match (opt.input, opt.header) {
-        (Some(input), true) => write(gen::generate_from_path(&input, &gen).header),
-        (Some(input), false) => write(gen::generate_from_path(&input, &gen).implementation),
-        (None, true) => write(include::HEADER),
+    let content;
+    let content = match (opt.input, opt.header) {
+        (Some(input), true) => {
+            content = gen::generate_from_path(&input, &gen).header;
+            content.as_slice()
+        }
+        (Some(input), false) => {
+            content = gen::generate_from_path(&input, &gen).implementation;
+            content.as_slice()
+        }
+        (None, true) => include::HEADER.as_bytes(),
         (None, false) => unreachable!(), // enforced by required_unless
+    };
+
+    match opt.output {
+        Output::Stdout => drop(io::stdout().write_all(content)),
+        Output::File(path) => fs::write(path, content)?,
     }
+
+    Ok(())
 }
diff --git a/gen/cmd/src/test.rs b/gen/cmd/src/test.rs
index 110e319..76101d9 100644
--- a/gen/cmd/src/test.rs
+++ b/gen/cmd/src/test.rs
@@ -31,6 +31,10 @@ OPTIONS:
             parse or even require the given paths to exist; they simply go
             into the generated C++ code as #include lines.
                \x20
+    -o, --output <output>
+            Path of file to write as output. Output goes to stdout if -o is
+            not specified.
+               \x20
     -V, --version
             Print version information.
 ";

